【力扣】用栈实现队列&&用队列实现栈 (用deque实现)

前置知识

Deque是一个双端队列接口,继承自Queue接口,Deque的实现类是LinkedList、ArrayDeque、LinkedBlockingDeque,其中LinkedList是最常用的。Deque的方法方便易用,在做栈或队列的题目时建议用Deque解答。
Deque常用操作:
在这里插入图片描述

题目

使用两个栈实现先入先出队列。队列应当支持一般队列支持的所有操作(push、pop、peek、empty):

实现 MyQueue 类:

  • void push(int x) 将元素 x 推到队列的末尾
  • int pop() 从队列的开头移除并返回元素
  • int peek() 返回队列开头的元素
  • boolean empty() 如果队列为空,返回 true ;否则,返回 false

假设所有操作都是有效的 (例如,一个空的队列不会调用 pop 或者 peek 操作)

思路:

一个栈stackIn模拟进队,一个栈stackOut模拟出队

  • 实现push():直接在 stackIn push
  • 实现pop():判断 stackOut 是否为空。 1)不为空则 stackOut.pop()。2)为空则先把 stackIn 的元素都导入到 stackOut 中,再 stackOut.pop()
  • 实现peek():判断 stackOut 是否为空。 1)不为空则 stackOut.peek()。2)为空则先把 stackIn 的元素都导入到 stackOut 中,再 stackOut.peek()
  • 实现isEmpty():stackIn 和 stackOut 都为空。

代码:

class MyQueue {
    private Deque<Integer> stackIn;
    private Deque<Integer> stackOut;
    public MyQueue() {
        this.stackIn = new LinkedList<>();
        this.stackOut = new LinkedList<>();
    }
    
    public void push(int x) {
        this.stackIn.offerFirst(x);
    }
    
    public int pop() {
        if(stackOut.isEmpty()){
            while(!stackIn.isEmpty()){
                this.stackOut.offerFirst(this.stackIn.pollFirst());
            }
        }
        return this.stackOut.pollFirst();
    }
    
    public int peek() {
        if(stackOut.isEmpty()){
            while(!stackIn.isEmpty()){
                this.stackOut.offerFirst(this.stackIn.pollFirst());
            }
        }
        return this.stackOut.peek();

    }
    
    public boolean empty() {
        return this.stackIn.isEmpty()&&this.stackOut.isEmpty();
    }
}

思路:

其实用一个队列就可以模拟堆栈。

  • 实现push():直接在 deque 尾部添加元素
  • 实现pop():将最后一个元素前面的所有元素依次出队入队,将最后一个元素弹出。
  • 实现peek():将最后一个元素前面的所有元素依次出队入队,返回最后一个元素。
  • 实现isEmpty():deque为空。

题目

使用两个队列实现先入后出堆栈。堆栈应当支持一般堆栈支持的所有操作(push、pop、peek、empty):

实现 MyStack类:

  • void push(int x) 将元素 x 推到队列的末尾
  • int pop() 从队列的开头移除并返回元素
  • int peek() 返回队列开头的元素
  • boolean empty() 如果队列为空,返回 true ;否则,返回 false

假设所有操作都是有效的 (例如,一个空的堆栈不会调用 pop 或者 peek 操作)

class MyStack {
    private Deque<Integer> deque;
    public MyStack() {
        this.deque = new LinkedList<>();
    }
    
    public void push(int x) {
        this.deque.offerLast(x);
    }
    
    public int pop() {
        for(int i=0;i<this.deque.size()-1;i++){
            this.deque.offerLast(this.deque.pollFirst());
        }
        return this.deque.pollFirst();
    }
    
    public int top() {
        for(int i=0;i<this.deque.size()-1;i++){
            this.deque.offerLast(this.deque.pollFirst());
        }
        Integer result = this.deque.pollFirst();
        this.deque.offerLast(result);
        return result;
    }
    
    public boolean empty() {
        return this.deque.isEmpty();
    }
}
  • 6
    点赞
  • 2
    收藏
    觉得还不错? 一键收藏
  • 1
    评论
请问您需要的是两个数组的交集元素还是交集元素的数量? 如果是交集元素,可以采用双指针的方式,先将两个数组排序,然后设定两个指针 i 和 j,分别指向两个数组的开头,比较两个指针所指向的元素的大小,如果相等,则说明找到了一个交集元素,将其存到结果数组中;如果不相等,则将指向小的元素的指针向后移动一位,直到其中一个指针越界为止。 代码实现如下: ```c int* intersect(int* nums1, int nums1Size, int* nums2, int nums2Size, int* returnSize){ int i = 0, j = 0, k = 0; int* res = (int*)malloc(sizeof(int) * (nums1Size > nums2Size ? nums2Size : nums1Size)); // 排序 qsort(nums1, nums1Size, sizeof(int), cmp); qsort(nums2, nums2Size, sizeof(int), cmp); while (i < nums1Size && j < nums2Size) { if (nums1[i] == nums2[j]) { res[k++] = nums1[i]; i++; j++; } else if (nums1[i] < nums2[j]) { i++; } else { j++; } } *returnSize = k; return res; } int cmp(const void* a, const void* b) { return *(int*)a - *(int*)b; } ``` 如果是交集元素的数量,可以采用哈希表的方式,用一个哈希表来记录第一个数组中的元素出现的次数,然后遍历第二个数组,在哈希表中查找是否存在相同的元素,如果存在,则说明找到了一个交集元素,将其计数并从哈希表中删除该元素,最后返回计数结果即可。 代码实现如下: ```c int* intersect(int* nums1, int nums1Size, int* nums2, int nums2Size, int* returnSize){ int i = 0, j = 0, k = 0; int* res = (int*)malloc(sizeof(int) * (nums1Size > nums2Size ? nums2Size : nums1Size)); int* hash = (int*)malloc(sizeof(int) * 1001); // 由于题目条件限制在 [0, 1000] 范围内,所以哈希表可以开得比较小 memset(hash, 0, sizeof(hash)); for (i = 0; i < nums1Size; i++) { hash[nums1[i]]++; } for (j = 0; j < nums2Size; j++) { if (hash[nums2[j]] > 0) { res[k++] = nums2[j]; hash[nums2[j]]--; } } *returnSize = k; return res; } ``` 希望这些代码能够帮到您,如有疑问请随时问我~

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值